#ifndef n_serverpushImageSource_H
#define n_serverpushImageSource_H

/*
 *
 * nucleo/image/source/serverpushImageSource.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/image/source/ImageSource.H>
#include <nucleo/core/URL.H>
#include <nucleo/network/http/HttpMessage.H>
#include <nucleo/network/tcp/TcpConnection.H>
#include <nucleo/image/encoding/Conversion.H>

namespace nucleo {

  // ------------------------------------------------------------------

  class serverpushImageSource : public ImageSource {

  private:

    int _nbImages ;
    unsigned int _quality ;
    Image::Encoding _encoding ;
 
    HttpMessage _msg ;

    std::string _hostname ;
    int _port ;
    TcpConnection *_connection ;
    std::string _request ;

    enum {CLOSED, OPEN, READY, BUFFERED} _state ;

    void networkSetup(const URL &url) ;
    void fileSetup(const URL &url) ;

  protected:

    void react(Observable*) ;

  public:

    serverpushImageSource(Image::Encoding e, const URL &url) ;
    ~serverpushImageSource(void) { stop() ; }

    bool start(void) ;
    bool isActive(void) { return (_state!=CLOSED) ; }
    bool getNextImage(Image *img) ;
    bool getLatestImage(Image *img) ;
    bool stop(void) ;

  } ;

  // ------------------------------------------------------------------

}

#endif
